
#include <machine.h>
#include "iodefine.h"
#include "ecu_init.h"
#include "rotation_speed.h"
#include "ignition.h"
#include "injection.h"
#include "intervaltimer.h"
#include "speed.h"
#include "iscv.h"

volatile unsigned short REVLIMIT;
volatile unsigned short REVLIMIT_CLR;
volatile unsigned short REV_FUELCUT;
volatile unsigned short IDL_RPM;
volatile unsigned short LOAD_RPM;
volatile unsigned short START_INJTIME;
volatile unsigned char DWELL;
volatile unsigned char INJRESUME;
volatile unsigned char INJRESUMEISCV;
volatile unsigned char ACCELCOMP_VAL;
volatile unsigned char ACCELCOMP_TH;
volatile unsigned char STARTTIMER;
volatile unsigned char ISCVMIN;
volatile unsigned char ISCVMAX;
volatile unsigned char ISCVDEF;


volatile unsigned char CPUdriving;		// X[vȂ
volatile unsigned short STATUS;			// ԕێ
volatile unsigned char CYLINDERS=100;	// ԏ㎀_̃JEg
volatile unsigned char IGf=0;		// _ΊmFJE^
volatile unsigned char AIR_TEMP=0;		// zCxiۂ̉x50lj
volatile unsigned char WATER_TEMP=0;	// pxiۂ̉x50lj
volatile unsigned char OIL_TEMP=0;		// GWICxiۂ̉x̂܂܁j
volatile unsigned char WATER_CORRECT=0;	// ␳W
volatile unsigned char AIR_CORRECT=0;	// zC␳W
volatile unsigned long long INJACCUM=0;	// CWFN^JَԂ̐ώZ[us]i8bytej
volatile unsigned short MONINJ=0;		// CWFN^Jَ[us]ij^pj
volatile unsigned char MONIGN=0;		// _Ύ[BTDC x]ij^pj


volatile unsigned short DEBUG1=0;
volatile unsigned short DEBUG2=0;

void WDT_init(void)
{
	WDTclr();
	WDT.WRITE.WTCSR=0xA5C7;	// 1100 0111 p[IZbg /4096	1/24000000*4096*255=43ms炢ŃI[o[tt[
}

void parameter_init(void)
{
	STATUS=0;
	REVLIMIT=CREVLIMIT;
	REVLIMIT_CLR=CREVLIMIT_CLR;
	REV_FUELCUT=CREV_FUELCUT;
	IDL_RPM=CIDL_RPM;
	LOAD_RPM=CLOAD_RPM;
	DWELL=CDWELL;
	INJRESUME=CINJRESUME;
	INJRESUMEISCV=CINJRESUMEISCV;
	ACCELCOMP_VAL=CACCELCOMP_VAL;
	ACCELCOMP_TH=CACCELCOMP_TH;
	STARTTIMER=CSTARTTIMER;
	ISCVMIN=CISCVMIN;
	ISCVMAX=CISCVMAX;
	ISCVDEF=CISCVDEF;
	
	STATUS|=SO2ERR;	// O2ZT[ُtOZbg ZT[̐퓮삪mFłNA
}

void ecu_init(void)
{
	CPUdriving=0x55;	// X[vɓĂ܂

	WDTstop();		// EHb`hbO^C}[~
	
	CPG.FRQCR.BIT.IFC=3;	// CPURANbN	 1:1/4 3:1/2 4:1/8
	CPG.FRQCR.BIT.BFC=3;	// oXNbN		 1:1/4 3:1/2 4:1/8
	CPG.FRQCR.BIT._PFC=3;	// ӃNbN		 1:1/4 3:1/2 4:1/8 oXNbNƎӃNbN͓lɂ邱 MTU2NbN葬oȂ
	CPG.FRQCR.BIT.MPFC=3;	// MTU2NbN		 1:1/4 3:1/2 4:1/8 RANbN葬oȂ
	
	// sUSI/O|[gɂ
/*	PFC.PACRL1.WORD=0;
	PFC.PACRL2.WORD=0;
	PFC.PACRL3.WORD=0;
	PFC.PACRL4.WORD=0;
	PFC.PBCRH1.WORD=0;
	PFC.PBCRL1.WORD=0;
	PFC.PBCRL2.WORD=0;
	PFC.PECRL1.WORD=0;
	PFC.PECRL2.WORD=0;
	PFC.PECRL3.WORD=0;
	PFC.PECRL4.WORD=0;
	
	//
	PFC.PECRL4.BIT.PE15MD=0;
	PFC.PECRL4.BIT.PE14MD=0;
	PFC.PECRL3.BIT.PE10MD=0;
	PFC.PACRL1.BIT.PA1MD=0;
	PFC.PBCRH1.BIT.PB16MD=0;
*/	
	//
	PFC.PEIORL.BIT.B10=1;	// o FEN
	PFC.PEIORL.BIT.B14=1;	// o MUTE
	PFC.PEIORL.BIT.B15=1;	// o MEN
	PFC.PAIORL.BIT.B1 =1;	// o PURGE
	PFC.PBIORH.BIT.B16=1;	// o AC RELAY

	// gp[qo͂ɂ
	PFC.PAIORL.BIT.B11=1;	// PA11
	PFC.PAIORL.BIT.B14=1;	// PA14
	PFC.PAIORL.BIT.B15=1;	// PA15
	PFC.PEIORL.BIT.B7=1;	// PE7
	PFC.PEIORL.BIT.B11=1;	// PE11
	PFC.PEIORL.BIT.B12=1;	// PE12
	PFC.PEIORL.BIT.B13=1;	// PE13
	PFC.PBIORL.BIT.B3=1;	// PB3
	PFC.PBIORL.BIT.B5=1;	// PB5

	MUTE=0;
	OUT_FEN=0;
	OUT_MEN=0;
	PURGE=0;
	AC_RELAY=0;
	
	ignition_init();
	injection_init();

	parameter_init();

	RPM_init();
	crank_init();
	knock_init();
	intervaltimer_init();
	speed_init();
	iscv_init();
	sci_init();
	
	WDT_init();
	
	set_imask(0);	// 荞݃}XN0Zbgil15̂܂܂Ɗ荞݂|ȂA
}
